//
// asteroids.cpp
// Classes like asteroids and some space trash are here
//

#include "stdafx.h"

///////////////////////////////////////////////////////////////////
// Asteroid class
/////////////////////////////////////////////////////////////////

TGame_asteroid :: TGame_asteroid ( TSurface * sf, int fx, int fy, int fsubtype ) : TGameElement( sf )
{
    x = fx;
    y = fy;
	esubtype = fsubtype;
    solid    = TRUE;
    imgnum   = IMAGE_ASTEROIDS;

    // per-subtype initialization
    switch (esubtype) {
        case 0: sprnum = 0;
                energy = 20;
                weight = 2;
		        break;
        case 1: sprnum = 1;
                energy = 40;
                weight = 8;
    			break;
		case 2: sprnum = 2;
                energy = 60;
                weight = 8;
				break;
	    case 3: sprnum = 3;
                energy = 80;
                weight = 12;
				break;
    }
}

// Drawing this class's object
//
void TGame_asteroid :: Draw ( void )
{
    draw_sprite(shadow_buffer, (int)x, (int)y, crect_fullscreen, surface->images[imgnum], (int)sprnum, TRUE, is_highlight);
    if (is_highlight == TRUE) is_highlight = FALSE;
}

// Main game elements processing routine //////////////////////////////////////////////////////
//
void TGame_asteroid :: TimerTick ( void )
{        
    if (destroy_this == TRUE) return;
    
    int dx = surface->images[imgnum]->dx[(int)sprnum];
    int dy = surface->images[imgnum]->dy[(int)sprnum];
    int i;

    if (ai_mode == AI_MODE_NORMAL) AdjustInertion();
    y += (speed / GAME_SPEED_KOEFF); if ((y-(dy>>1)) > screen_dy) { destroy_this = TRUE; return; }

    switch (ai_mode) {
      // preparing to destruction
      case AI_MODE_ZEROENERGY_PREPARE:
        solid   = FALSE;
        speed   = speed / 3.0;
        imgnum  = IMAGE_BOOM_1;
        sprnum  = 0;
        ai_mode = AI_MODE_ZEROENERGY;
        i = surface->LocateFreeGE(GM_AREA_UP1);
        if (i >= 0) surface->game_elements[i] = new TGame_particles(surface, x, y, 8, IMAGE_PARTICLES_2);
        surface->sounds->PlaySample(SOUND_BOOM1);
        break;
      case AI_MODE_ZEROENERGY:
        if ((int)sprnum >= surface->images[imgnum]->count) destroy_this = TRUE; else sprnum += 1;
        break;
    }
}
