//
// gfxdraw.h
// 

#ifndef __GFXDRAW_H__
#define __GFXDRAW_H__


// for frame buffer in 2003SE/WM5 systems
//
#ifndef GETRAWFRAMEBUFFER
#define GETRAWFRAMEBUFFER   0x00020001

#define FORMAT_565 1
#define FORMAT_555 2
#define FORMAT_OTHER 3

typedef struct _RawFrameBufferInfo
{
   WORD wFormat;
   WORD wBPP;
   VOID *pFramePointer;
   int  cxStride;
   int  cyStride;
   int  cxPixels;
   int  cyPixels;
} RawFrameBufferInfo;

#endif // GETRAWFRAMEBUFFER


// Image class
//
class TImage {
    public:
        WORD    count;
        WORD    * dx;
        WORD    * dy;
        WORD    * isalpha;
        LPWORD  * data;
        DWORD   * datasize;

        BOOL    is_disposable;

        TImage ( LPCTSTR fname, BOOL load_compressed );
        ~TImage ();
};


////////////////////////////////////////

extern    RawFrameBufferInfo  screen_rfbi;

extern    int                 screen_dx;
extern    int                 screen_dy;
extern    int                 screen_size;
extern    int                 screen_mode;

extern    int                 screen_brightness;
extern    int                 screen_brightness_dir;

extern    LPWORD              shadow_buffer;

extern    RECT                crect_fullscreen;

extern void draw_sprite ( LPWORD fbuf, int x, int y, RECT clip_rect, TImage * img, int sprnum, BOOL centered, BOOL highlight );
extern void draw_string ( LPWORD fbuf, int x, int y, RECT clip_rect, LPCTSTR s, TImage * img, int sprnum, int fdx, int fdy );
extern void draw_hline  ( LPWORD fbuf, int x, int y, int len, WORD color, int alpha, RECT clip_rect );
extern void draw_vline  ( LPWORD fbuf, int x, int y, int len, WORD color, int alpha, RECT clip_rect );

extern void LoadImagesFromFolder ( TImage ** images, LPCTSTR sfolder, BOOL __disposable );

extern BOOL InitGfx ( void );
extern void DeinitGfx ( void );
extern void DrawShadowBuffer ( void );


#endif // __GFXDRAW_H__
