<?php

  //
  // Converting files XXXX.png to one .454 file
  // Used for making animation images for mainmenu and so on...
  //

  include '../../../utils.php';

  /////////////////////////////////////////////////////////////////////////////

  $pngfiles = findfile('.', '/^\d\d\d\d\.(png|PNG|pnG|pNg|pNG|Png|PnG|PNg)$/');
  sort($pngfiles);

  $sprcount = 0;
  $sprnum = 0;

  $fcount = count($pngfiles);

  $outfname = "000_mmani.454";
  $g = fopen($outfname, "w");
  write_word($g, 1);

  $starty = 120; // cropping source images from this line
  echo $infname." -> ".$outfname.", starting from $starty line\n";

  for ($idx=0; $idx < $fcount; $idx++)
  {
    $infname = $pngfiles[$idx];

    list($dx, $dy) = getimagesize($infname);
    $img = ImageCreateFromPng($infname);

    // write out dimensions
    write_word($g, $dx);
    write_word($g, ($dy-$starty));

    // use alpha channel or not
    // (!) no alpha channel in animation images ( ,  )
    write_word($g, 0);

    $data = "";
    for ($i=$starty; $i<$dy; $i++)
      for ($j=0; $j<$dx; $j++) {
        $rgb = ImageColorAt($img, $j, $i);

        $ca = ($rgb >> 24) & 0x7F;  // Alpha (0..127)
        $cr = ($rgb >> 16) & 0xFF;  // Red   (0..255)
        $cg = ($rgb >> 8) & 0xFF;   // Green (0..255)
        $cb = $rgb & 0xFF;          // Blue  (0..255)

        $ca = $ca >> 4; // Alpha 3-bits
        $cr = $cr >> 4; // Red   4-bits
        $cg = $cg >> 3; // Green 5-bits
        $cb = $cb >> 4; // Blue  4-bits

        $cr = intval(round($cr * (1.0 - ($ca / 7.0))));
        $cg = intval(round($cg * (1.0 - ($ca / 7.0))));
        $cb = intval(round($cb * (1.0 - ($ca / 7.0))));

        $w = (($ca << 13) | ($cr << 9) | ($cg << 4) | $cb) & 0xFFFF;
        $data = $data . chr($w & 0xFF);
        $data = $data . chr(($w>>8) & 0xFF);
      }

    // resulting data will be compressed
    $compdata = gzcompress($data, 9);
    $w = strlen($compdata);
    // write compressed data size
    write_word($g, ($w & 0xFFFF));
    write_word($g, (($w>>16) & 0xFFFF));
    // write compressed data itself
    fwrite($g, $compdata, $w);

    $sprcount++;
  }

  fseek($g, 0, SEEK_SET);
  write_word($g, $sprcount);
  fclose($g);
?>