//
// interior.h
// Header for interior.cpp
//

#ifndef __INTERIOR_H__
#define __INTERIOR_H__




// Background stars class
//
class TGame_fstars: public TGameElement {
    public:
        int         count;                      // current used stars count [0..FSTARS_MAX_NUMBER]
        int         fx [FSTARS_MAX_COUNT];      // X coordinate of a star's upper left corner
        double      fy [FSTARS_MAX_COUNT];      // Y
        int         fsprite [FSTARS_MAX_COUNT]; // sprite number of that star
        double      fspeed  [FSTARS_MAX_COUNT]; // speed factor of that star

        TGame_fstars ( TSurface * sf, int num );
        void Draw ( void );
        void TimerTick ( void );
};


// Particles (some trash that came out of burst center)
//
class TGame_particles: public TGameElement {
    public:
        int         fcount;
        double      fx[PARTICLES_MAX_COUNT];
        double      fy[PARTICLES_MAX_COUNT];
        int         fimage[PARTICLES_MAX_COUNT];
        double      fsprite[PARTICLES_MAX_COUNT];
        double      fdx[PARTICLES_MAX_COUNT];
        double      fdy[PARTICLES_MAX_COUNT];
        double      fcenter_x;
        double      fcenter_y;

        TGame_particles ( TSurface * sf, double __x, double __y, int num, int __imgnum );
        void Draw ( void );
        void TimerTick ( void );
};


// Interior class
//
class TGame_interior: public TGameElement {
    public:
        TGame_interior ( TSurface * sf, int fx, int fy, int fsubtype, int fimgnum );
        void Draw ( void );
        void TimerTick ( void );
};



#endif // __INTERIOR_H__
