//
// mainmenu.h
// Header for mainmenu.cpp
//

#ifndef __MAINMENU_H__
#define __MAINMENU_H__


#define MM_SPRNUM_NEWGAME  0
#define MM_SPRNUM_CONTINUE 1
#define MM_SPRNUM_OPTIONS  2
#define MM_SPRNUM_ABOUT    3
#define MM_SPRNUM_EXIT     4


// Main menu class
//
class TMainMenu {
    public:

        TSurface * surface;

        int      menu_level;
        int      menu_tick;

        int      selected_action;

        TImage   * img_bgr;
        TImage   * img_all;

        int      sprnum_back;
        int      grid_tick;

        int      btn_start_state;   // 0 - normal, 1 - half light, 2 - full light
        int      btn_start_dir;     // 0 - go to state 0, 1 - go to state 2
        int      btn_options_state;
        int      btn_options_dir;
        int      btn_about_state;
        int      btn_about_dir;
        int      btn_exit_state;
        int      btn_exit_dir;


        TMainMenu  ( TSurface * sf );
        ~TMainMenu ();

        void Load         ( void );
        void Unload       ( void );
        void SetMenuLevel ( int ml );

        void Draw      ( void );
        void TimerTick ( void );

        void OnMouseDown ( int mx, int my );
        void OnMouseUp   ( int mx, int my );
};


#endif // __MAINMENU_H_
