//
// smoke.cpp 
// Classes for smoke effects
//

#include "stdafx.h"


TGame_smoke :: TGame_smoke ( TSurface * sf ) : TGameElement( sf )
{
    int i;

    for (i=0; i<MAX_SMOKE_ELEMENTS; i++) fimage[i] = -1;
}

void TGame_smoke :: Draw ( void )
{
    int i;

    for (i=0; i<MAX_SMOKE_ELEMENTS; i++) if (fimage[i] >= 0)
        draw_sprite(shadow_buffer, (int)fx[i], (int)fy[i], crect_fullscreen, surface->images[fimage[i]], (int)fsprite[i], TRUE/* center */, FALSE/*hlight*/);
}

void TGame_smoke :: TimerTick ( void )
{
    int i;

    for (i=0; i<MAX_SMOKE_ELEMENTS; i++) if (fimage[i] >= 0)
    {
      fsprite[i] += 0.5;
      if (fsprite[i] >= surface->images[fimage[i]]->count) fimage[i] = -1;
    }
}

void TGame_smoke :: AddSmoke ( int __x, int __y, int __imgnum )
{
    int i;
    for (i=0; i<MAX_SMOKE_ELEMENTS; i++) if (fimage[i] < 0)
    {
      fsprite[i] = -0.5; // negative - will be delayed drawing
      fx[i] = __x;
      fy[i] = __y;
      fimage[i] = __imgnum;
      return;
    }
}
